#include "EATestVentStruct.h"

// start PICO i -1.5, 0, 0.2 for å starte inni røret
EATestVentStruct::EATestVentStruct(){
  //used for the purposes of defining the structures pos and rot
  geom = dCreateSphere(0, 1);
  dGeomSetBody(geom, 0);									

  dMatrix3 R1, R2, R3;

  //Create each separate vent and set up their relative position and rotatio
  // 0 = "T", 1 = "L", 2 = "I"
  // (t, H, W, L)
/*  vents[0] = new Vent(2, 0.3, 0.3, 2.0);
  relPos[0][0] = 0.05;
  relPos[0][1] = 0;
  relPos[0][2] = 0; 
  relPos[0][3] = 0;
  dRFromAxisAndAngle(relRot[0],0,1,0,90*PI/180);

  vents[0] = new Vent(1, 0.3, 0.1, 0.3);
  relPos[0][0] = -1.1;
  relPos[0][1] = 0;
  relPos[0][2] = -0.1;
  relPos[0][3] = 0;
  dRFromAxisAndAngle(relRot[0], 1, 0, 0, 90*PI/180);
  dRFromAxisAndAngle(relRot[0], 0, 0, 1, -90*PI/180);


  vents[0] = new Vent(0, 0.3, 0.3, 0.3);
  relPos[0][0] = -1.1;
  relPos[0][1] = 0;
  relPos[0][2] = 0.1;
  relPos[0][3] = 0;
 //wtf skjer ved 90 grader?
  dRFromAxisAndAngle(relRot[0], 0, 0, 1, 89.9*PI/180);

  //  ----- 
  vents[1] = new Vent(2, 0.3, 0.3, 1.0);
  relPos[1][0] = -1.75;
  relPos[1][1] = 0;
  relPos[1][2] = 0.1; 
  relPos[1][3] = 0;
  dRFromAxisAndAngle(relRot[1],0,1,0,90*PI/180);
 
/*
  vents[4] = new Vent(1, 0.3, 0.1, 0.3);
  relPos[4][0] = -2.4;
  relPos[4][1] = 0;
  relPos[4][2] = 0;
  relPos[4][3] = 0;
  dRFromAxisAndAngle(relRot[4], 1, 0, 0, 90*PI/180);
  dRFromAxisAndAngle(relRot[4], 0, 0, 1, -90*PI/180);

  vents[5] = new Vent(0, 0.3, 0.3, 0.3);
  relPos[5][0] = -2.4;
  relPos[5][1] = 0;
  relPos[5][2] = 0.2;
  relPos[5][3] = 0;
 //wtf skjer ved 90 grader?
  dRFromAxisAndAngle(relRot[5], 0, 0, 1, 89.9*PI/180);

  // -----
  vents[6] = new Vent(2, 0.3, 0.3, 1.0);
  relPos[6][0] = -3.05;
  relPos[6][1] = 0;
  relPos[6][2] = 0.2; 
  relPos[6][3] = 0;
  dRFromAxisAndAngle(relRot[6],0,1,0,90*PI/180);

 
  vents[7] = new Vent(1, 0.3, 0.1, 0.3);
  relPos[7][0] = -3.7;
  relPos[7][1] = 0;
  relPos[7][2] = 0.1;
  relPos[7][3] = 0;
  dRFromAxisAndAngle(relRot[7], 1, 0, 0, 90*PI/180);
  dRFromAxisAndAngle(relRot[7], 0, 0, 1, -90*PI/180);

  vents[8] = new Vent(0, 0.3, 0.3, 0.3);
  relPos[8][0] = -3.7;
  relPos[8][1] = 0;
  relPos[8][2] = 0.3;
  relPos[8][3] = 0;
 //wtf skjer ved 90 grader?
  dRFromAxisAndAngle(relRot[8], 0, 0, 1, 89.9*PI/180);

  // -----
  vents[9] = new Vent(2, 0.3, 0.3, 1.0);
  relPos[9][0] = -4.35;
  relPos[9][1] = 0;
  relPos[9][2] = 0.3; 
  relPos[9][3] = 0;
  dRFromAxisAndAngle(relRot[9],0,1,0,90*PI/180);

  vents[10] = new Vent(1, 0.3, 0.3, 0.3);
  relPos[10][0] = -5;
  relPos[10][1] = 0;
  relPos[10][2] = 0.3;
  relPos[10][3] = 0;
  dRFromAxisAndAngle(relRot[10], 1, 0, 0, 90*PI/180);
  dRFromAxisAndAngle(relRot[10], 0, 0, 1, -90*PI/180);

  vents[11] = new Vent(2, 0.3, 0.3, 1.0);
  relPos[11][0] = -5;
  relPos[11][1] = 0;
  relPos[11][2] = 0.95; 
  relPos[11][3] = 0;

  vents[12] = new Vent(1, 0.3, 0.3, 0.3);
  relPos[12][0] = -5;
  relPos[12][1] = 0;
  relPos[12][2] = 1.3;
  relPos[12][3] = 0;
 //wtf skjer ved 90 grader?
  dRFromAxisAndAngle(relRot[12], 0, 0, 1, 89.9*PI/180);



  vents[13] = new Vent(2, 0.3, 0.3, 1.0);
  relPos[13][0] = -5.65;
  relPos[13][1] = 0;
  relPos[13][2] = 1.3; 
  relPos[13][3] = 0;
  dRFromAxisAndAngle(relRot[13],0,1,0,90*PI/180);

  
  vents[14] = new Vent(1, 0.3, 0.3, 0.3);
  relPos[14][0] = -6;
  relPos[14][1] = 0;
  relPos[14][2] = 1.3;
  relPos[14][3] = 0;
*/

}

void EATestVentStruct::setPosition(dReal x,dReal y, dReal z){
  dGeomSetPosition(geom, x, y, z);
  dVector3 origo = {x,y,z,0};
  const dReal* R = dGeomGetRotation(geom);

  for(int i=0; i<NUM_PARTS; i++){
    dVector3 worldRelPos;				//relative position in the world space
    dMatrix3 worldRelRot;				//rotation in the world space

    dMultiply0(worldRelPos,R,relPos[i],3,3,1);
    vents[i]->setPosition(origo[0]+worldRelPos[0],origo[1]+worldRelPos[1],origo[2]+worldRelPos[2]);
		
    dMultiply0(worldRelRot,R,relRot[i],3,3,3);
    vents[i]->setRotation(worldRelRot);
  }
}
void EATestVentStruct::setRotation(const dMatrix3 R){
  dGeomSetRotation(geom, R);
  const dReal* origo = dGeomGetPosition(geom);

  for(int i=0; i<NUM_PARTS; i++){
    dVector3 worldRelPos;				//relative position in the world space
    dMatrix3 worldRelRot;				//rotation in the world space

    dMultiply0(worldRelPos,R,relPos[i],3,3,1);
    vents[i]->setPosition(origo[0]+worldRelPos[0],origo[1]+worldRelPos[1],origo[2]+worldRelPos[2]);
		
    dMultiply0(worldRelRot,R,relRot[i],3,3,3);
    vents[i]->setRotation(worldRelRot);
  }
}

void EATestVentStruct::addToSpace(dSpaceID space){
  for(int i=0; i<NUM_PARTS; i++){
    vents[i]->addToSpace(space);
  }
}

void EATestVentStruct::addToViewer(Viewer *v){
  if (v==NULL)
    return;
  for(int i=0; i<NUM_PARTS; i++){
    vents[i]->addToViewer(v);
  }
}
