#include "StatObject.h"

StatObject::StatObject(dGeomID g)
{
	geom = g;
}

StatObject::~StatObject()
{
}


dGeomID StatObject::getGeom() {
	return geom;
}

void StatObject::addToSpace(dSpaceID space)
{
	dSpaceAdd(space, geom);
}

void StatObject::setPosition(dReal x, dReal y, dReal z)
{
	dGeomSetPosition(geom, x, y, z);
}

void StatObject::setRotation(const dMatrix3 R)
{
	dGeomSetRotation(geom, R);
}

const dReal *StatObject::getPosition()
{
	return dGeomGetPosition(geom);
}

const dReal *StatObject::getRotation()
{
	return dGeomGetRotation(geom);
}
