#ifndef ANN_H
#define ANN_H

#include <vector>
using namespace std;

class ANN
{	
private:
	vector<int> layout;
	vector<double> weights;
	vector<int> matrix_position;

	unsigned int layout_weights;
	unsigned int layout_nodes;

public:
	ANN(const vector<int> &layout, const vector<double> &weights);
	void getOutput(const vector<double> &inputs, vector<double> &outputs);
	double getWeight(unsigned int layer, unsigned int from, unsigned int to);

	unsigned int layoutNodes() {return layout_nodes;};
	unsigned int layoutWeights() {return layout_weights;};
};

#endif
