#include <cstdlib>
#include <iostream>
#include "EAUniqueInteger.h"

using namespace std;

EAUniqueInteger::EAUniqueInteger()
{
	EAUniqueInteger(10);
}

EAUniqueInteger::EAUniqueInteger(unsigned int size)
{
	this->size = size;

	for (unsigned int i=0;i<size;i++) {
		list.push_back((int)i);
	}

	randomize();
}

void EAUniqueInteger::randomize(void)
{
	for (unsigned int i=0;i<list.size()*2;i++) {
		unsigned int a = rand()%list.size();
		unsigned int b = rand()%list.size();	
		int temp = list[a];
		list[a] = list[b];
		list[b] = temp;
	}
}

void EAUniqueInteger::mutate(double p)
{
	for (unsigned int i=0;i<list.size();i++) {
		if ( ((double)rand()/RAND_MAX) < p ) {
			unsigned int a = rand()%list.size();
			int temp = list[a];
			list[a] = list[i];
			list[i] = temp;
		}
	}
}

EAIndividual *EAUniqueInteger::crossover(EAIndividual *g)
{
	EAIndividual *child = new EAUniqueInteger(*this);
	return child;

}

void EAUniqueInteger::print(void)
{
	for (unsigned int i=0;i<list.size();i++) {
		cout << list[i] << "-";
	}
	
	cout << "F="<< getFitness() << endl;
}
