#ifndef EAINTEGER_H
#define EAINTEGER_H

#include <vector>
#include "EAIndividual.h"

class EAUniqueInteger: public EAIndividual
{
private:
	unsigned int size;
	std::vector<int> list;
public:
	EAUniqueInteger();
	EAUniqueInteger(unsigned int size);
	
	std::vector<int> *integer_list() {return &list;};

	EAIndividual *copy(void) {
		return new EAUniqueInteger(*this);
	};
	
	void randomize(void);
	void mutate(double p);
	EAIndividual *crossover(EAIndividual *g);
	void print(void);
};

#endif
