#ifndef SNAKE_H
#define SNAKE_H

#include "EAProblem.h"
#include "ANN.h"

#include <vector>
#include <string>

#include "../simulator/Simulator.h"

class Snake: public EAProblem
{

private:
  //	std::vector<point_t> tsp_point;
	int timesteps;
	std::vector<int> annLayout;
			
	unsigned int weights;	
	Simulator *simulator;
	bool visual;

public:
	Snake();
	//Snake(const char *file);
	//	bool LoadFromFile(const char *file);
	void graphBest(void);

	double calc_fitness(EAIndividual *individual);
	void pop_init(void);
	void setVisual(bool value) { visual = value; }
};

#endif
