#include <cstdlib>
#include <iostream>
#include "SnakeIndividual.h"

using namespace std;

SnakeIndividual::SnakeIndividual()
{
  //  SnakeIndividual(5);
}

SnakeIndividual::SnakeIndividual(unsigned int nodes, unsigned int size)
{
  for (unsigned int i=0;i<nodes;i++) {
    list.push_back(new EADouble(size));
  }
}

SnakeIndividual::SnakeIndividual(vector<EADouble*> *wagons)
{
  this->list = *wagons;
}

void SnakeIndividual::mutate(double p)
{
  //cout << this->list.size();
  for(int i=0; i<this->list.size() ;i++){
    list[i]->mutate(p);
  }
}

EAIndividual *SnakeIndividual::crossover(EAIndividual *g)
{
  vector<EADouble*> newSnake;
  for(int i=0;i<this->list.size();i++){
    SnakeIndividual* partner = dynamic_cast<SnakeIndividual*>(g);
    newSnake.push_back((EADouble *) list[i]->crossover(partner->wagon_list()[i]));
  }
  return new SnakeIndividual(&newSnake);
}

void SnakeIndividual::print(void)
{
	
}

void SnakeIndividual::randomize()
{
  
}
