#ifndef SNAKEINDIVIDUAL_H
#define SNAKEINDIVIDUAL_H

#include <vector>
#include "EAIndividual.h"
#include "EADouble.h"

class SnakeIndividual: public EAIndividual
{
 private:
  std::vector<EADouble*> list;
 public:
  SnakeIndividual();
  SnakeIndividual(unsigned int nodes, unsigned int size);
  SnakeIndividual(std::vector<EADouble*> *wagons);
	
  std::vector<EADouble*> &wagon_list() {return list;};

  EAIndividual *copy(void) {
    return new SnakeIndividual(*this);
  };
  void randomize(void);
  void mutate(double p);
  EAIndividual *crossover(EAIndividual *g);
  void print(void);
};

#endif
