#ifndef TSP_H
#define TSP_H

#include "EAProblem.h"
#include <vector>
#include <string>

typedef struct {
	float x, y;
}point_t;

class TSP: public EAProblem
{

private:
	std::vector<point_t> tsp_point;
public:
	TSP();
	TSP(const char *file);
	bool LoadFromFile(const char *file);
	void graphBest(void);

	double calc_fitness(EAIndividual *individual);
	void pop_init(void);
};

#endif
