#include "StatBox.h"

StatBox::StatBox(int type) //not in use
{
	geom = dCreateSphere(0, 0.002);

	dGeomSetBody(geom, 0);
}

StatBox::StatBox(int type, dReal dimx, dReal dimy, dReal dimz)
{
	dimension[0] = dimx;
	dimension[1] = dimy;
	dimension[2] = dimz;

	geom = dCreateBox(0, dimension[0], dimension[1], dimension[2]);
	
	dGeomSetBody(geom, 0);
}

void StatBox::addToViewer(Viewer *v)
{
	if (v==NULL)
		return;
	node = v->getSceneManager()->addCubeSceneNode(1);
	dGeomSetData(geom, node);

	node->setScale(vector3df(dimension[0], dimension[1], dimension[2]));

	node->setMaterialTexture(0, v->getVideoDriver()->getTexture("../media/wood.ppm"));
	node->setMaterialFlag(video::EMF_LIGHTING, false);
	
	v->addObject(this->geom);
}
